const Day = document.querySelector('.day');
const month = document.querySelector('.month-name');
const date = new Date();

const pre = document.querySelector('.left');
const next = document.querySelector('.right');

const input = document.querySelector('input[type="text"]');



let currentMon = date.getMonth()+1;   
let currentYear = date.getFullYear();
let currentDay = date.getDate();

let DayOfChoice = currentDay;
let MonOfChoice = currentMon;
let yearOfChoice = currentYear;

let yearOfDisplay = 0;
let monOfDisplay = 0;

let year = currentYear;
let mon = currentMon;

let clickEventArr = [];
let storeToDo = [];

let selDate ;

function isLeapYear(year){
    return (year%4==0)&&(year%400==0||year%100!=0);
}

function getDayOfMon(mon,year){
    if(mon===1||mon===3||mon===5||mon===7||mon===8||mon===10||mon===12){
        return 31;
    }
    else if(mon===2){
        return isLeapYear(year)? 29 : 28;
    }
    else{
        return 30;
    }
}

function getDay(year,mon,date){
    const conYMD = year+'-'+mon+'-'+date;
    return(new Date(conYMD).getDay());
}
function makeCalendar(year,mon,dayCount){
    clickEventArr=[];
    Day.innerHTML='';
    let getFirstDay = getDay(year,mon,1);
    let previousMon;
    if(currentMon-1<0){
        previousMon = 12;
    }
    else{
        previousMon = currentMon - 1;
    }
    let getDayOfPreMon = getDayOfMon(previousMon,year);
    for(let i=(getFirstDay+6)%7; i>0; i--){
        const listPre = document.createElement('li');
        listPre.textContent = `${getDayOfPreMon-(i-1)}`;
        listPre.style.opacity = '0.5';
        listPre.classList.add('disabled');

        Day.appendChild(listPre);
    }

    for(let i=1; i<=dayCount; i++){

        var inputDate =  "R"+year+"-"+(mon<10?"0"+mon:mon+"")+"-"+ (i<10?"0"+i:i+"");
        var dayResult = this.studyResultList[inputDate]==undefined?false:this.studyResultList[inputDate];

        if(i===currentDay&&year===currentYear&&mon===currentMon){
            //선택한 년, 월, 일 다를 때 현재 날짜에 검은색 테두리
            const onlyOneList = document.createElement('li');

            onlyOneList.textContent = `${i}`;
            if(currentYear === yearOfChoice && currentMon === MonOfChoice && currentDay === DayOfChoice){
                //오늘날짜 색상.
                onlyOneList.style.background = '#fff1bb';
            }

            if(0===getDay(year,mon,i)){
                onlyOneList.style.color = 'red';
            }
            else if(6==getDay(year,mon,i)){
                onlyOneList.style.color = 'blue';
            }

            const spanSmile = document.createElement('div');

            // 오늘날짜 스마일 표시
            if(currentYear === yearOfChoice && currentMon === MonOfChoice && currentDay === DayOfChoice){
                if(dayResult == true ){
                    spanSmile.innerHTML = '<span style="font-size:2rem;color:#66cc00;"><i class="axi axi-smile-o"></i><span>';
                }else{
                    spanSmile.innerHTML = '<span style="font-size:2rem;color:#b4b4b4;"><i class="axi axi-frown-o"></i><span>';
                }
            }

            onlyOneList.appendChild(spanSmile);
            Day.appendChild(onlyOneList);

            continue;
        }

        const list = document.createElement('li');
        list.textContent = `${i}`;
        if(i===DayOfChoice&&year===yearOfChoice&&mon===MonOfChoice){
            list.style.border = '3px solid rgb(39 255 0)';
            Day.addEventListener('click',(event)=>{
                if(event.target!==list){
                    list.style.border = 'none';
                }
            });
        }    

        if(0===getDay(year,mon,i)){
            list.style.color = 'red';
            list.style.marginRight=0;
        }
        else if(6==getDay(year,mon,i)){
            list.style.color = 'blue';
        }

        const spanSmile = document.createElement('div');


        let selMonth  = parseInt(this.yearOfDisplay+""+(this.monOfDisplay<=9?"0"+this.monOfDisplay:this.monOfDisplay));
        let currMon   = parseInt(currentYear+""+(currentMon<=9?"0"+currentMon:currentMon));

        // 학습한 결과가 있으면 스마일 없으면 울상.
        if(selMonth === currMon && i<=currentDay){
            if(dayResult == true ){
                spanSmile.innerHTML = '<span style="font-size:2rem;color:#66cc00;"><i class="axi axi-smile-o"></i><span>';
            }else{
                spanSmile.innerHTML = '<span style="font-size:2rem;color:#b4b4b4;"><i class="axi axi-frown-o"></i><span>';
            }
        }

        if(selMonth < currMon){
            if(dayResult == true ){
                spanSmile.innerHTML = '<span style="font-size:2rem;color:#66cc00;"><i class="axi axi-smile-o"></i><span>';
            }else{
                spanSmile.innerHTML = '<span style="font-size:2rem;color:#b4b4b4;"><i class="axi axi-frown-o"></i><span>';
            }
        }

        list.appendChild(spanSmile);
        Day.appendChild(list);
    }
}

function setMonthTitle(year,mon){
    month.textContent = `${year}.${mon}`
    this.yearOfDisplay = year;
    this.monOfDisplay = mon;
}

function nextMonthOrYear(){
    if(mon===12){
        year = year+1;
        mon = 1;
    }
    else{
        mon = mon+1;
    }
    setMonthTitle(year,mon);
    makeCalendar(year,mon,getDayOfMon(mon,year));
}

function preMonthOrYear(){
    if(mon===1){
        year = year-1;
        mon = 12;
    }
    else{
        mon = mon-1;
    }
    setMonthTitle(year,mon);
    makeCalendar(year,mon,getDayOfMon(mon,year));
}


function main(){
    setMonthTitle(year,mon);
    makeCalendar(year,mon,getDayOfMon(mon,year));
}


pre.addEventListener('click',preMonthOrYear);
next.addEventListener('click',nextMonthOrYear);


function clearEvent(){
    clickEventArr.forEach((value)=>{
        value.style.border = 'none';
    });
}

Day.addEventListener('click',(event)=>{
    //debugger;
    if(event.target.tagName==='UL')return;
    if(event.target.className!=='disabled'){
        //console.log(event.target.tagName);
        clearEvent();
        //event.target.style.border='3px solid red';
        DayOfChoice = (event.target.textContent)*1;
        MonOfChoice = mon;
        yearOfChoice = year;
        
        clickEventArr.push(event.target);
        //console.log(clickEventArr);
        //input.focus();
        if(event.target.tagName =="li" ||  event.target.tagName =="LI"){
            let selectDate = year+"-"+(mon<10?"0"+mon:mon+"")+"-"+ (DayOfChoice<10?"0"+DayOfChoice:DayOfChoice+"");

            $("#selDate").val(selectDate);
            getDayContent(selectDate);
        }

        if(event.target.tagName =="i" || event.target.tagName =="I" ){
           let day = event.target.parentNode.parentNode.parentNode.textContent;
           let selectDate = year+"-"+(mon<10?"0"+mon:mon+"")+"-"+(day.length==1?"0"+day:day);
           $("#selDate").val(selectDate);
           getDayContent(selectDate);
        }
    }
    
});

function keepStore(){
    const YMD = year+'-'+mon+'-'+DayOfChoice;
    let arrayToDo;
    let arr = new Array();
    const elementToDo = document.createElement('li');
    if(!localStorage.getItem(YMD)){
        return arr;
    }
    if(localStorage.getItem(YMD).includes(',')){
        arrayToDo = localStorage.getItem(YMD).split(',');
        arrayToDo.forEach((value)=>{
            arr.push(value);
        });
    }
    else{
        arr.push(localStorage.getItem(YMD));
    }
    return arr;
}


