package kr.co.iyapp.todayen.dao;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import kr.co.iyapp.todayen.util.AppConfig;
import kr.co.iyapp.todayen.util.DBUtil;

public class TodayEnglishDAO {

    private String TAG = "";

    private Context context;
    private SQLiteDatabase mDb;
    private DBUtil dbutl;


    public TodayEnglishDAO(Context context) {
        this.context = context;
        this.TAG = context.getClass().getName();
        dbutl = new DBUtil(context);
    }

    public void getAppConfig(AppConfig config) {
        Cursor mCur = null;
        try {
            // DB connetion
            mDb = dbutl.connetion();

            JSONArray list = new JSONArray();
            StringBuffer selectSql =  new StringBuffer();

            selectSql.append("\nselect");
            selectSql.append("\n        thc_id,");
            selectSql.append("\n        keys,");
            selectSql.append("\n        label,");
            selectSql.append("\n        case");
            selectSql.append("\n             when keys == 'reviewGbn' then ( case when  (  select  count(1) as 'cnt'  from  study_content where study_date = (select max(study_date) from  study_content where study_date != date('now', 'localtime'))  ) > 0 then value else 'N'  end )");
            selectSql.append("\n             else value");
            selectSql.append("\n        end as \"value\"");
            selectSql.append("\n  from study_config\n");

            Log.d(TAG, "selectSql >>> " + selectSql.toString());

            mCur = mDb.rawQuery(selectSql.toString() , null);

            if (mCur != null) {
                // 칼럼의 마지막까지
                while (mCur.moveToNext()) {
                    JSONObject json = new JSONObject();
                    try {
                        json.put("id"     , mCur.getString(0));
                        json.put("keys"   , mCur.getString(1));
                        json.put("label"  , mCur.getString(2));
                        json.put("value"  , mCur.getString(3));

                        if(mCur.getString(1).equals("dayCnt") ){
                            config.setDayCtn( json.getInt("value"));
                        }

                    } catch (Exception e1) {
                        e1.getMessage();
                    }
                    list.put(json);
                }
            }

            Log.d(TAG, "getAppConfig >>" + list);

            //전역 AppConfig 에 설정 정보 input..
            config.setConfig(list);

        } catch (SQLException sqle) {
            Log.e(TAG, "getAppConfig >>" + sqle.toString());
            throw sqle;
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
    }// method end

    public JSONArray getAppConfig(String pageGbn) {
        Cursor mCur = null;
        try {
            // DB connetion
            mDb = dbutl.connetion();

            JSONArray list = new JSONArray();

            StringBuffer selectSql =  new StringBuffer();

            selectSql.append("\nselect");
            selectSql.append("\n        thc_id,");
            selectSql.append("\n        keys,");
            selectSql.append("\n        label,");
            if(pageGbn.equals("config")) {
                selectSql.append("\n      value");
            }else{
                selectSql.append("\n        case");
                selectSql.append("\n             when keys == 'reviewGbn' then ( case when  (  select  review_act_gbn   from  study_day_master  where study_date = (select max(study_date) from  study_content where study_date != date('now', 'localtime'))  ) == 'N' then value else 'N'  end )");
                selectSql.append("\n             else value");
                selectSql.append("\n        end as \"value\"");
            }
            selectSql.append("\n  from study_config\n");

            Log.d(TAG, "selectSql >>> " + selectSql.toString());

            mCur = mDb.rawQuery(selectSql.toString() , null);

            if (mCur != null) {
                // 칼럼의 마지막까지
                while (mCur.moveToNext()) {
                    JSONObject json = new JSONObject();
                    try {
                        json.put("id"     , mCur.getString(0));
                        json.put("keys"   , mCur.getString(1));
                        json.put("label"  , mCur.getString(2));
                        json.put("value"  , mCur.getString(3));

                    } catch (Exception e1) {
                        e1.getMessage();
                    }
                    list.put(json);
                }
            }

            Log.d(TAG, "getAppConfig >>" + list);

            return list;
        } catch (SQLException sqle) {
            Log.e(TAG, "getAppConfig >>" + sqle.toString());
            throw sqle;
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
    }// method end

    public JSONArray getStudyContent(String todayGbn, String correctGbn) {
        Cursor mCur = null;
        try {
            // DB connetion
            mDb = dbutl.connetion();

            String incorrectSql ="";
            if("renew".equals(correctGbn)){
                incorrectSql = " and incorrect ='N' ";
            }

            String sql = "";
            
            // todayGbn ["today":오늘, "reStudy":복습, "2020-01-01":특정일]
            if(todayGbn.equals("today")){
                // 구분자가 오늘이면 오늘날짜로  생성된 데이터가 있는지 확인한 후 가져옴

                //date('now' ,'-1 day') 어제...
                String  countSql = "select id from  study_content where study_date = date('now', 'localtime')";
                mCur = mDb.rawQuery( countSql , null);

                //Log.d(TAG, "count >>>> " + mCur.getCount());

                if(mCur.getCount() > 0){
                    // 카운트가 0보다 크면 오늘 날짜데이터를 랜덤으로 가져옴
                    sql = "select * from  study_content where study_date = date('now', 'localtime') "+incorrectSql+" order by random() limit (select value from study_config where keys ='dayCnt')";
                }else{
                    // 카운트가 0이면 선택된 날짜가 없는날중에 랜덤으로 가져옴
                    sql = "select * from  study_content where study_date is null "+incorrectSql+" order by random() limit (select value from study_config where keys ='dayCnt')"+incorrectSql;
                }
            }else if(todayGbn.equals("reStudy")){
                // 구분자가 오늘이 아니면 즉 복습이면 오늘이 아닌 날중에 가장 마지막날(max(study_date)) 틀린거 상관 없이 학습
                // incorrectSql 없어야 함
                sql = "select * from  study_content where study_date = (select max(study_date) from  study_content where study_date != date('now', 'localtime') ) order by random()" ;
            }else{
                sql = "select * from  study_content where study_date = date('"+todayGbn+"')  "+incorrectSql+" order by random()";
            }

            Log.d(TAG, "sql >>>> \n□□□□ " + sql);

            mCur = mDb.rawQuery( sql , null);

            JSONArray list = new JSONArray();

            if (mCur != null) {
                // 칼럼의 마지막까지
                while (mCur.moveToNext()) {
                    JSONObject json = new JSONObject();
                    try {
                        json.put("id"            , mCur.getString(0));
                        json.put("word"          , mCur.getString(1));
                        json.put("meaning"       , mCur.getString(2));
                        json.put("wordCls"       , mCur.getString(3));
                        json.put("studyDate"     , mCur.getString(4));
                        json.put("level"         , mCur.getString(5));
                        json.put("useYn"         , mCur.getString(6));
                        json.put("incorrect"     , mCur.getString(7));

                    } catch (Exception e1) {
                        e1.getMessage();
                    }
                    list.put(json);
                }
            }

            if(todayGbn.equals("today")) {
                updateStudyDay(list);
            }
            Log.d(TAG, "getAppConfig >>" + list);

            return list;
        } catch (SQLException sqle) {
            Log.e(TAG, "getStudyContent >>" + sqle.toString());
            throw sqle;
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
    }// method end


    public JSONArray getStudyContent(String date ) {
        Cursor mCur = null;
        try {
            // DB connetion
            mDb = dbutl.connetion();

            String sql = "";

            // 구분자가 오늘이 아니면 즉 복습이면 오늘이 아닌 날중에 가장 마지막날(max(study_date))
            sql = "select * from  study_content where study_date = '"+date+"' order by random() ";

            Log.d(TAG, "sql >>>> \n□□□□ " + sql);

            mCur = mDb.rawQuery( sql , null);

            JSONArray list = new JSONArray();

            if (mCur != null) {
                // 칼럼의 마지막까지
                while (mCur.moveToNext()) {
                    JSONObject json = new JSONObject();
                    try {
                        json.put("id"            , mCur.getString(0));
                        json.put("word"          , mCur.getString(1));
                        json.put("meaning"       , mCur.getString(2));
                        json.put("wordCls"       , mCur.getString(3));
                        json.put("studyDate"     , mCur.getString(4));
                        json.put("level"         , mCur.getString(5));
                        json.put("useYn"         , mCur.getString(6));
                        json.put("incorrect"     , mCur.getString(7));

                    } catch (Exception e1) {
                        e1.getMessage();
                    }
                    list.put(json);
                }
            }

            Log.d(TAG, "getAppConfig >>" + list);

            return list;
        } catch (SQLException sqle) {
            Log.e(TAG, "getStudyContent >> \n□□□□ " + sqle.toString());
            throw sqle;
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
    }// method end

    //오늘 날짜 insert.. study_content , study_day_master
    public void updateStudyDay(JSONArray list) {
        mDb = dbutl.connetion();


        String today = "";
        String sql = "select * from (select date('now', 'localtime') as today ) ";

        Cursor mCur = mDb.rawQuery( sql , null);

        //Log.d(">>>>>>>>>>>>>>>>>>>>>>> ####################### mCur", mCur.toString());

        if (mCur != null) {
            // 칼럼의 마지막까지
            while (mCur.moveToNext()) {
                today = mCur.getString(0);
            }
           //Log.d(">>>>>>>>>>>>>>>>>>>>>>> #######################", today);
        }


        try {
            String id = "";
            try {
                for(int i=0;i<list.length();i++){
                    id += "'"+(list.getJSONObject(i)).getString("id")+"',";
                }

                if(id.length()>0){
                    id = id.substring(0 , id.length()-1);
                }

            } catch (JSONException mSQLException) {
                Log.e(TAG, "getTestData >>" + mSQLException.toString());
            }

            String updateSql = "update study_content set study_date = '"+today+"' where id in ("+id+") ";
            Log.d(TAG, "updateSql >>>> \n□□□□ " + updateSql);

            mDb.execSQL(updateSql);

            mergeDayMaster(today, "N");
        } catch (SQLException mSQLException) {
            Log.e(TAG, "getTestData >>" + mSQLException.toString());
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }

    public void updateRemoveStudyDay() {
        mDb = dbutl.connetion();
        try {

            String updateSql = "update study_content set study_date = null where study_date = date('now', 'localtime')";
            Log.d(TAG, "updateSql >>>> \n□□□□ " + updateSql);

            mDb.execSQL(updateSql);
        } catch (SQLException mSQLException) {
            Log.e(TAG, "getTestData >>" + mSQLException.toString());
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }

    public void insertTime() {
        mDb = dbutl.connetion();
        try {
            mDb.execSQL("insert into take_medicine (druggin_date, title1, drugging_time1) values (date('now', 'localtime'),'아침',time('now', 'localtime'))");
        } catch (SQLException mSQLException) {
            Log.e(TAG, "getTestData >>" + mSQLException.toString());
            throw mSQLException;
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }

    public JSONArray getTodayStudyContent(String today) {
        Cursor mCur = null;
        try {
            // DB connetion
            mDb = dbutl.connetion();

            JSONArray list = new JSONArray();

            String sql = "select * from  study_content where study_date = today";
            Log.d(TAG, "sql >>>> \n□□□□ " + sql);

            mCur = mDb.rawQuery( sql , null);

            if (mCur != null) {
                // 칼럼의 마지막까지
                while (mCur.moveToNext()) {
                    JSONObject json = new JSONObject();
                    try {
                        json.put("id"            , mCur.getString(0));
                        json.put("word"          , mCur.getString(1));
                        json.put("meaning"       , mCur.getString(2));
                        json.put("wordCls"       , mCur.getString(3));
                        json.put("studyDate"     , mCur.getString(4));
                        json.put("level"         , mCur.getString(5));
                        json.put("useYn"         , mCur.getString(6));
                        json.put("incorrect"     , mCur.getString(7));

                    } catch (Exception e1) {
                        e1.getMessage();
                    }
                    list.put(json);
                }
            }

            Log.d(TAG, "getAppConfig >>" + list);

            return list;
        } catch (SQLException sqle) {
            Log.e(TAG, "getStudyContent >>" + sqle.toString());
            throw sqle;
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
    }// method end

    public void updateDayCnt(String cnt) {
        mDb = dbutl.connetion();
        try {

            String updateSql = "update study_content set value = cnt where keys ='dayCnt' ";
            Log.d(TAG, "updateSql >>>> \n□□□□ " + updateSql);

            mDb.execSQL(updateSql);
        } catch (SQLException mSQLException) {
            Log.e(TAG, "updateDayCnt >>" + mSQLException.toString());
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }

    public void updateIncorrect(String correctGbn , String id) {
        mDb = dbutl.connetion();
        try {

            String updateSql = "update study_content set incorrect = '"+correctGbn+"' where id = '"+id+"'";
            Log.d(TAG, "updateSql >>>> \n□□□□ " + updateSql);

            mDb.execSQL(updateSql);
        } catch (SQLException mSQLException) {
            Log.e(TAG, "updateIncorrect >>" + mSQLException.toString());
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }

    public JSONArray getTestExample(String date, String wordId) {
        Cursor mCur = null;
        try {
            // DB connetion
            mDb = dbutl.connetion();

            JSONArray list = new JSONArray();

            String sql ="";
                   sql  += " select * from  (";
                   sql  += " select * from  ";
                   sql  += " (select * from  study_content where id != '"+wordId+"' order by random() limit 4)";
                   sql  += " union all ";
                   sql  += " select * from  study_content where  id = '"+wordId+"' ";
                   sql  += " ) order by id ";

            Log.d(TAG, "sql >>>> \n□□□□ " + sql);

            mCur = mDb.rawQuery( sql , null);

            if (mCur != null) {
                // 칼럼의 마지막까지
                while (mCur.moveToNext()) {
                    JSONObject json = new JSONObject();
                    try {
                        json.put("id"            , mCur.getString(0));
                        json.put("word"          , mCur.getString(1));
                        json.put("meaning"       , mCur.getString(2));
                        json.put("wordCls"       , mCur.getString(3));
                        json.put("studyDate"     , mCur.getString(4));
                        json.put("level"         , mCur.getString(5));
                        json.put("useYn"         , mCur.getString(6));
                        json.put("incorrect"     , mCur.getString(7));

                    } catch (Exception e1) {
                        e1.getMessage();
                    }
                    list.put(json);
                }
            }

            Log.d(TAG, "getAppConfig >>" + list);

            return list;
        } catch (SQLException sqle) {
            Log.e(TAG, "getStudyContent >>" + sqle.toString());
            throw sqle;
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
    }// method end


    public JSONArray getTestResult(String date) {
        Cursor mCur = null;
        try {
            // DB connetion
            mDb = dbutl.connetion();

            JSONArray list = new JSONArray();

            String sql ="select id, word, meaning, word_cls, study_date, level, useyn, incorrect from  study_content where study_date = '"+date+"' order by id";

            Log.d(TAG, "sql >>>> \n□□□□ " + sql);

            mCur = mDb.rawQuery( sql , null);

            if (mCur != null) {
                // 칼럼의 마지막까지
                while (mCur.moveToNext()) {
                    JSONObject json = new JSONObject();
                    try {
                        json.put("id"            , mCur.getString(0));
                        json.put("word"          , mCur.getString(1));
                        json.put("meaning"       , mCur.getString(2));
                        json.put("wordCls"       , mCur.getString(3));
                        json.put("studyDate"     , mCur.getString(4));
                        json.put("level"         , mCur.getString(5));
                        json.put("useYn"         , mCur.getString(6));
                        json.put("incorrect"     , mCur.getString(7));

                    } catch (Exception e1) {
                        e1.getMessage();
                    }
                    list.put(json);
                }
            }

            Log.d(TAG, "getAppConfig >>" + list);

            return list;
        } catch (SQLException sqle) {
            Log.e(TAG, "getStudyContent >>" + sqle.toString());
            throw sqle;
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
    }// method end


    public int updateConfig(String keys , String value) {
        int result = 0;
        mDb = dbutl.connetion();
        try {

            ContentValues  param = new ContentValues();
            param.put("value", value);

            result = mDb.update("study_config" , param , "keys=?" , new String[] {keys} );

        } catch (SQLException mSQLException) {
            Log.e(TAG, "updateConfig >>" + mSQLException.toString());
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
        return result;
    }

    public JSONObject getStudyResult() {
        Cursor mCur = null;

        JSONObject obj = new JSONObject();
        try {
            // DB connetion
            mDb = dbutl.connetion();
            String sql = "select study_date from  study_day_master "  ;
            Log.d(TAG, "sql >>>> \n□□□□ " + sql);

            mCur = mDb.rawQuery( sql , null);

            if (mCur != null) {
                // 칼럼의 마지막까지
                try{
                    while (mCur.moveToNext()) {
                        obj.put("R"+mCur.getString(0)  , true);
                    }
                }catch(JSONException j){
                    Log.e(TAG, "getStudyResult >>" + j.toString());
                }
            }
        } catch (Exception e) {
            Log.e(TAG, "getStudyResult >>" + e.toString());
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
        return obj;
    }// method end

    public void mergeDayMaster(String day, String reviewActGbn) {
        mDb = dbutl.connetion();
        try {
            String sql ="insert or replace into study_day_master (study_date, review_act_gbn) values ('"+day+"', '"+reviewActGbn+"') ";
            mDb.execSQL(sql);
            Log.d("mergeDayMaster sql >>>> \n", sql);
        } catch (SQLException mSQLException) {
            Log.e(TAG, "mergeDayMaster >>" + mSQLException.toString());
            throw mSQLException;
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }

    public void deleteRemoveStudyDayMaster() {
        mDb = dbutl.connetion();
        try {

            String deleteSql  = "delete from study_day_master  where  study_date= date('now', 'localtime')";
            Log.d(TAG, "deleteSql >>>> \n□□□□ " + deleteSql);
            mDb.execSQL(deleteSql);

        } catch (SQLException mSQLException) {
            Log.e(TAG, "getTestData >>" + mSQLException.toString());
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }


    public void insertDayPoint(String day, String point) {
        mDb = dbutl.connetion();
        try {
            String sql ="insert  into study_day_point (study_date, test_seq, test_point) values (date('"+day+"'), (select count(study_date)+1 as cnt from study_day_point sdp where study_date = date('"+day+"')) , "+point+") ";
            mDb.execSQL(sql);
            Log.d("sql >>>> \n", sql);
        } catch (SQLException mSQLException) {
            Log.e(TAG, "mergeDayMaster >>" + mSQLException.toString());
            throw mSQLException;
        } finally {
            if (mDb != null) {
                mDb.close();
            }
        }
    }

    public JSONObject getStudyDayMaster(String date) {
        Cursor mCur = null;

        JSONObject obj = new JSONObject();
        try {
            // DB connetion
            mDb = dbutl.connetion();
            String sql = "\n select " ;
            sql +="\n	   study_date";
            sql +="\n	,  ifnull(review_act_gbn, 'N') as review_act_gbn  ";
            sql +="\n	,  case";
            sql +="\n		   when cnt > 0 then 'Y' else 'N'";
            sql +="\n	  end as review_is_gbn";
            sql +="\nfrom";
            sql +="\n	(";
            sql +="\n	select";
            sql +="\n		date('"+date+"') as study_date,";
            sql +="\n		(select  review_act_gbn from study_day_master where study_date = date('"+date+"')) as  review_act_gbn,";
            sql +="\n		(select	count(*) from study_day_master	where study_date != date('"+date+"') ) as cnt";
            sql +="\n    )";

            Log.d(TAG, "sql >>>> \n□□□□ " + sql);

            mCur = mDb.rawQuery( sql , null);

            if (mCur != null) {
                // 칼럼의 마지막까지
                try{
                    while (mCur.moveToNext()) {
                        obj.put("studyDate"    , mCur.getString(0));
                        obj.put("reviewActGbn" , mCur.getString(1));
                        obj.put("reviewIsGbn"  , mCur.getString(2));
                    }
                }catch(JSONException j){
                    Log.e(TAG, "getStudyDayMaster >>" + j.toString());
                }
            }
            Log.d(TAG, "getStudyDayMaster >>" + obj);
        } catch (Exception e) {
            Log.e(TAG, "getStudyDayMaster >>" + e.toString());
        } finally {
            if (mCur != null) {
                mCur.close();
            }
            if (mDb != null) {
                mDb.close();
            }
        }
        return obj;
    }// method end
}
